//MineSweeper-----the ultimate game........
#include <cstdio>		//including various standard header files and libraries required 
#include "rect.h"
#include "ezwin.h"
#include "bitmap.h"
#include <ctime>
#include <cmath>
#include <cstring>
#include <sstream>
#include <cstdlib>
#include <iostream>
#include <cassert>


using namespace std;

//The following header files have being created by the programmers to improve the efficiency of writing and compiling the code

#include "VariablesDeclaration.h"	
#include "minsweeper2.cpp"
#include "Screens.h"
#include "MouseClickEvent.h"






//This is the main function.
int ApiMain(){
        
	
	//Asking the player about the level of the game to be played
	cout<<"Game level:\n";
	cout<<"1.easy\n2.medium\n3.hard\nenter level(1-3):\n";
	cin>>level;

	 switch(level)

	{
			case 1: m=8;n=8;p=10;		//Defining the grid size of the "easy" level=8X8 .Number of mines present(p)=10
				//cout<<m<<'\t'<<n<<'\n';
				break;
			case 2: m=10;n=10;p=40;		//Defining the grid size of the "medium" level=16X16 .Number of mines present(p)=40
				//cout<<m<<'\t'<<n<<'\n';
				break;
			case 3: m=15;n=15;p=99;		//Defining the grid size of the "difficult" level=30X16 .Number of mines present(p)=99
				//cout<<m<<'\t'<<n<<'\n';
				break;
			default: cout<<"Wrong choice.Prong terminated\n";
				 return 1;
	}
	
        gameboard=setmines(m,n,p);		//Initialising the gameboard and randomly setting of the mines
	int i,j;
	problemboard=new cell*[m];
  	for(i=0;i<m;i++)
	   problemboard[i]=new cell[n];
	for(i=0;i<m;i++)
	{
		for(j=0;j<n;j++)
		{
			problemboard[i][j].setnum(-2);		//Initially all the blocks have been initialised to -2
		}
	}
    
    MineSweeper.Open();		//Opens the SimpleWindow MineSweeper.
	//GamePlayScreen();
    GameMenuScreen();		//Calls the GameMenuScreen function where the main menu of the game is displayed.
    
   // Whenever mouse is clicked MouseClickEvent function will be called  
   MineSweeper.SetMouseClickCallback(MouseClickEvent);	
   
}
