# include<iostream>
# include<stdlib.h>
# include<time.h>
using namespace std;
class cell
{	private:
            int flag;
            int num;
	public:
	    cell()
	    {
		flag=0;
		num=0;
	    }

            void setflag();
            void setnum(int);
            int getflag();
            int getnum();
};

void cell::setflag()
{
	flag=1;
}
void cell::setnum(int n)
{
	//cout<<"num : "<<n<<endl;
	num=n;
}
int cell::getflag()
{
	return flag;
}
int cell::getnum()
{
	return num;
}
cell **gameboard;
	cell **problemboard;

cell** setmines(int m,int n,int nofmines)
{

	int i,j,k,l;
	srand(time(0));
	int count=0;

        cell **gameboard=new cell*[m];
  	for(i=0;i<m;i++)
	   gameboard[i]=new cell[n];


	while(count<nofmines)
	{
		i=(rand())%m;
		j=(rand())%n;
		if(gameboard[i][j].getnum()!=-1)
		{
			gameboard[i][j].setnum(-1);
			//cout<<i<<","<<j<<" mine set"<<endl;

			for(k=i-1;k<=i+1;k++)
			{
				for(l=j-1;l<=j+1;l++)
				{
					if((k>=0 && k<m) && (l>=0 && l<n))
					{	if((k==i && l==j) || gameboard[k][l].getnum()==-1)
						{	//cout<<"i and j are equal"<<endl;
							continue;

						}
						//cout<<"Incremented "<<k<<","<<l<<"pair"<<endl;
						gameboard[k][l].setnum(gameboard[k][l].getnum()+1);
					}
				}
			}


			count++;
		}
	}
	/*for(i=0;i<m;i++)
	{
		for(j=0;j<n;j++)
		{
			cout<<gameboard[i][j].getnum()<<" ";
		}
		cout<<endl;
	}*/
	return gameboard;
}
void openzero(int i, int j,int rowsize,int columnsize,cell** gameboard,cell** problemboard)
{
	for(int k=i-1;k<=i+1;k++)
	{
		for(int l=j-1;l<=j+1;l++)
		{
			if((k>=0 && k<rowsize) && (l>=0 && l<columnsize))
			{
				if( problemboard[k][l].getflag()==1)
				continue;
				
				problemboard[k][l].setnum(gameboard[k][l].getnum());
				
				if(gameboard[k][l].getnum()==0 )
				{
						problemboard[k][l].setflag();
						
						openzero(k,l,rowsize,columnsize,gameboard,problemboard);
				}
				else if( problemboard[k][l].getnum()!=0 )
				{
						problemboard[k][l].setflag();
			
				}

				
			}
		}
	}
}
int open(int i,int j,int m,int n,int choice,cell** gameboard,cell** problemboard)//1 for left click and 2 for right click 
{
	if(choice==1)
	{
		if(gameboard[i][j].getnum()==-1)
		return 1;
		else
		{	
			//cout<<"i j :"<<i<<" "<<j<<endl;
			problemboard[i][j].setnum(gameboard[i][j].getnum());

			problemboard[i][j].setflag();
			if(problemboard[i][j].getnum()==0)
			{
				openzero(i,j,m,n,gameboard,problemboard);
			}
			return 0;
		}
	}
	else
	{
		problemboard[i][j].setnum(-1);
		//cout<<"Set";
		return 0;
	}
}
int compare(int row,int column,cell** gameboard,cell** problemboard)
{
	int flag=0;
	for(int i=0;i<row;i++)
	{
		for(int j=0;j<column;j++)
		{
			if(gameboard[i][j].getnum()!=problemboard[i][j].getnum())
			flag=1;
		}
	}
	return flag;
SimpleWindow MyWindow("Minesweeper", 30, 30,
		      Position(3.0, 1.0));
int row;
int column;
int flag[10][10]={0};
void Draw(int ,int,int );
// Routine for handling mouse click events 
int do_click(const Position &p) { 
     // display the position the user clicked in the text window 
     column=(int) p.GetXDistance();
	row=(int)p.GetYDistance(); 
if(flag[row][column]==1) 
{
	Draw(row,column,gameboard[row][column].getnum());
	if (gameboard[row][column].getnum()==0)
	openzero(row,column,8,8,gameboard,problemboard);
}
	//cout<<row<<" "<<column<<endl;

else{
BitMap Photo(MyWindow);
Photo.Load("mine.xpm");
assert(Photo.GetStatus()==BitMapOkay);
flag[row][column]=1;
//cout<<row<<"   "<<column;


Position PhotoPosition=Position(column+.2,row+.2);
Photo.SetPosition(PhotoPosition);
Photo.Draw();
}
    return 1;

}

}

int Apimain()
{
	 int i,j;


	int m,p,n,level,ch,row,column,result,result1;
	int success=0;int mines=0;


  MyWindow.Open();
  assert(MyWindow.GetStatus() == WindowOpen);

  // Colors: {White, Red, Green, Blue, Yellow, Cyan, Magenta};

  //Green Rectangle, with  border
  for(i=0;i<8;i++)
  {
	for(j=0;j<8;j++)
	{
  		MyWindow.RenderRectangle(Position(i,j), Position(i+1,j+1),
		   Red, true);
	}
 } 
	



	

	/*cout<<"Game level:\n";
	cout<<"1.easy\n2.medium\n3.hard\nenter level(1-3):\n";
	cin>>level;

 switch(level)

{
		case 1: m=8;n=8;p=10;
			//cout<<m<<'\t'<<n<<'\n';
			break;
		case 2: m=16;n=16;p=40;
			//cout<<m<<'\t'<<n<<'\n';
			break;
		case 3: m=30;n=16;p=99;
			//cout<<m<<'\t'<<n<<'\n';
			break;
		default: cout<<"Wrong choice.Prong terminated\n";
			 return 1;
}*/
m=8;n=8;p=10;
	gameboard=setmines(m,n,p);

	problemboard=new cell*[m];
  	for(i=0;i<m;i++)
	   problemboard[i]=new cell[n];
	for(i=0;i<m;i++)
	{
		for(j=0;j<n;j++)
		{
			problemboard[i][j].setnum(-2);
		}
	}


	/*for(int i=0; i<m;i++)
	{  for(int j=0;j<n;j++)
	   	cout<<gameboard[i][j].getnum()<<"\t";
	   cout<<endl;
	}*/
while(success==0)
{
	MyWindow.SetMouseClickCallback(do_click); 
	result=open(row,column,m,n,ch,gameboard,problemboard);
	//cout<<result;
	if(result==1)
	{
		cout<<"GAME OVER";
		return 0;
	}				
	if(result==0)
	{ 
		for(i=0; i<m;i++)
		{  for( j=0;j<n;j++)
	   		cout<<problemboard[i][j].getnum()<<"\t";
	   	cout<<endl;
		}
			
		if(mines==p)
		{
			result1=compare(m,n,gameboard,problemboard);
			if(result1==0)
			{
				success=1;
				cout<<"Congragulations, you have successfully completed the game"<<endl;
			}
		}
	}
}		
return 0;
}

void Draw(int row,int column,int num)
{	
	// Create bounding box for text
	Position UpperLeft = Position(column+0.5,row+0.5);
	Position LowerRight = Position(column+0.5,row+0.5);

	// Display the text
	char a=(char)num;
	MyWindow.RenderText(UpperLeft, LowerRight, &a);
}

